#include <string.h>
#include <signal.h>
#include <sys/time.h>

#include "timer.h"

/* alarm will occur after this many micro-seconds */
#define INIT_USEC 1000000

void init_timer(void) {
   reset_timer();
   signal(SIGALRM,SIG_IGN);
};

void reset_timer(void) {
   struct itimerval it;
   memset(&it,0,sizeof(it));
   it.it_value.tv_usec=INIT_USEC;
   setitimer(ITIMER_REAL,&it,NULL);
};

int read_timer(void) {
   struct itimerval it;
   getitimer(ITIMER_REAL,&it);
   if(it.it_value.tv_sec>0) return 0;
   return (INIT_USEC-it.it_value.tv_usec)/USEC_PER_TICK;
};
